<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 37.30-40-50-60</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
<!-- Data Table-->
<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>
  <!---------User's Table------------->
  <div class="container">
    <div class="text-center my-4">
      <h2>Danh sách người dùng đăng ký</h2>
    </div>
    <div>
      <button id="btn-add-user" class="btn btn-success col-2 form-group">Add user</button>
    </div>
    <table id="table-user" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Id</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Country</th>
          <th>Subject</th>
          <th>Customer Type</th>
          <th>Register Status</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>
        </tbody>
    </table>
  </div>
  <!---------Modal - Create a User------------->
  <div id="create-user-modal" class="modal" tabindex="-1" role="dialog">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Create New User</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
            <div class="row form-group">   
              <div class="col-sm-4 col-form-label">
                <label >First Name</label>
              </div>
              <div class="col-sm-8">
                <input id="inp-first-name" type="text" class="form-control" placeholder="input firstname">
              </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-4 col-form-label">
                  <label >Last Name</label>
                </div>
                <div class="col-sm-8">
                  <input id="inp-last-name" type="text" class="form-control" placeholder="input lastname">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-4 col-form-label">
                  <label >Subject</label>
                </div>
                <div class="col-sm-8">
                  <input id="inp-subject" type="text" class="form-control" placeholder="input subject">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-4 ">
                  <label >Country</label>
                </div>
                <div class="col-sm-8">
                  <select id="select-country" class="form-control">
                    <option value="VN"> Vietnam</option>
                    <option value="USA"> USA</option>
                    <option value="AUS"> Australia</option>
                    <option value="CAN"> Canada</option>
                  </select>
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-4 col-form-label">
                  <label >Customer Type</label>
                </div>
                <div class="col-sm-8">
                  <select id="select-customer-type" class="form-control">
                    <option value="Standard"> Standard </option>
                    <option value="Gold"> Gold </option>
                    <option value="Premium"> Premium </option>
                  </select>
                </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4 col-form-label">
                <label >Register Status</label>
              </div>
              <div class="col-sm-8">
                <select id="select-register-status" class="form-control">
                  <option value="New"> New </option>
                  <option value="Accepted"> Accepted </option>
                  <option value="Denied"> Denied </option>
                </select>
              </div>
          </div>
        </div>
        <div class="modal-footer">
          <button id="btn-user-create" type="button" class="btn btn-primary">Create</button>
          <button id="btn-create-cancel" type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
        </div>
      </div>
    </div>
  </div>

  <!---------Modal - Update User's data------------->
  <div id="edit-user-modal" class="modal" tabindex="-1" role="dialog">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Update User's Data</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
            <div class="row form-group">   
              <div class="col-sm-4 col-form-label">
                <label >First Name</label>
              </div>
              <div class="col-sm-8">
                <input id="inp-first-name-edit" type="text" class="form-control" placeholder="input firstname">
              </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-4 col-form-label">
                  <label >Last Name</label>
                </div>
                <div class="col-sm-8">
                  <input id="inp-last-name-edit" type="text" class="form-control" placeholder="input lastname">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-4 col-form-label">
                  <label >Subject</label>
                </div>
                <div class="col-sm-8">
                  <input id="inp-subject-edit" type="text" class="form-control" placeholder="input subject">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-4 ">
                  <label >Country</label>
                </div>
                <div class="col-sm-8">
                  <select id="select-country-edit" class="form-control">
                    <option value="VN"> Vietnam</option>
                    <option value="USA"> USA</option>
                    <option value="AUS"> Australia</option>
                    <option value="CAN"> Canada</option>
                  </select>
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-4 col-form-label">
                  <label >Customer Type</label>
                </div>
                <div class="col-sm-8">
                  <select id="select-customer-type-edit" class="form-control">
                    <option value="Standard"> Standard </option>
                    <option value="Gold"> Gold </option>
                    <option value="Premium"> Premium </option>
                  </select>
                </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4 col-form-label">
                <label >Register Status</label>
              </div>
              <div class="col-sm-8">
                <select id="select-register-status-edit" class="form-control">
                  <option value="New"> New </option>
                  <option value="Accepted"> Accepted </option>
                  <option value="Denied"> Denied </option>
                </select>
              </div>
          </div>
        </div>
        <div class="modal-footer">
          <button id="btn-user-edit" type="button" class="btn btn-primary">Edit</button>
          <button id="btn-edit-cancel" type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
        </div>
      </div>
    </div>
  </div>

<!---------Modal - Delete User's data------------->
<div id="delete-user-modal" class="modal" tabindex="-1" role="dialog">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <div class="text-center">
          <label style="font-size: 30px;" >Are you sure to delete this user? </label>
        </div>
      </div>
      <div class="modal-footer">
        <button id="btn-user-detele" type="button" class="btn btn-danger">Delete</button>
        <button id="btn-edit-delete" type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
      </div>
    </div>
  </div>
</div>

  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
   
    //set properties of the table's data
    const gUSER_COLs = ['id', 'firstname', 'lastname', 'country', 'subject', 'customerType', 'registerStatus', 'action'];

    //set columns for the table
    const gID_COL = 0;
    const gFIRST_NAME_COL = 1;
    const gLAST_NAME_COL = 2;
    const gCOUNTRY_COL = 3;
    const gSUBJECT_COL = 4;
    const gCUSTOMER_STYLE_COL = 5;
    const gREGISTER_STATUS_COL = 6;
    const gACTION_COL = 7;

    ///set global variable for the property of "id"
    var gVId = "";

    //declare datable and mapping columns
    var gUserTable = $("#table-user").DataTable({
        columns: [
            {data: gUSER_COLs[gID_COL]},
            {data: gUSER_COLs[gFIRST_NAME_COL]},
            {data: gUSER_COLs[gLAST_NAME_COL]},
            {data: gUSER_COLs[gCOUNTRY_COL]},
            {data: gUSER_COLs[gSUBJECT_COL]},
            {data: gUSER_COLs[gCUSTOMER_STYLE_COL]},
            {data: gUSER_COLs[gREGISTER_STATUS_COL]},
            {data: gUSER_COLs[gACTION_COL]},
        ],
        columnDefs: [
          {
            targets: gACTION_COL,
            className: "text-center",
            defaultContent: `
              <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
              <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
            `
          }
        ]
     });
        

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    
    //load the page
    $(document).ready(function(){
      
      //load page
      onPageLoading()
      
      //show modal of CREATE new user
      $("#btn-add-user").on('click', function(){
        modalUserCreation()
      });

      //add event for CREATE button
      $("#btn-user-create").on('click', function(){
        btnUserCreateClick()
      })

      //show modal of user EDIT
       $("#table-user").on('click', ".edit-user", function(){
        modalUserEdit(this);
      });

      //add event for EDIT button
      $("#btn-user-edit").on('click', function(){
        btnUserEditClick()
      });

      //add event for DELETE modal
      $("#table-user").on('click', ".delete-user", function(){
        modalUserDelete(this);
      });

      //add event for DELETE button
      $("#btn-user-detele").on('click', function(){
        btnDeleteConfirm(this);
      })
    
    });


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    
    //function for loading the web page
    function onPageLoading(){
      callApiGetUserData();
    };

    //USER CREATION - function on showing the modal of user's creation
    function modalUserCreation(){
      $("#create-user-modal").modal('show');
    };

    //USER CREATION - function for button of user's creation
    function btnUserCreateClick(){

      //get the inputed data
      var vUserData = getInputData();

      //validate the input data
      var vValidRes = validateInputData(vUserData);
      
      if (vValidRes){
        //call API to create the new user and update to server
        addUserByApiCall(vUserData);
      };
    } 
 
    //USER EDIT - function on showing the modal of user's edit
    function modalUserEdit(paramEdit){
      $("#edit-user-modal").modal('show');

      var vUserId = rowIdClick(paramEdit);
      console.log(vUserId)

      callApiGetUserById(vUserId);

    };

    //USER EDIT - function for button of user's edit
    function btnUserEditClick(){

      //load the user by id
      var vUserEdit = readDataOnEditModal()
          console.log(vUserEdit) ; 
      //validate the input data
      var vValidRes = validateInputData(vUserEdit);

      if (vValidRes){
        //call API to create the new user and update to server
        editUserByApiCall(vUserEdit.id, vUserEdit)
      };
      
    } 

    //USER DELETE - function to open delete's modal
    function modalUserDelete(){
      $("#delete-user-modal").modal("show");
    }

    //USER DELETE - function to call API for delete user
    function btnDeleteConfirm(paramDelete){

      var vTable = $("#table-user .delete-user");
      var vId = rowIdClick(vTable);

      //call API for deleting user on the server
      $.ajax({
        url: gBASE_URL + gVId,
        type: "DELETE",
        success: function(res){
          alert("The user's id " + vId +  " has been deleted successully");
          callApiGetUserData();
          $("#delete-user-modal").modal("hide");
        },
        error: function(ajaxContext){
          console.log(ajaxContext.status);
        }
      });      

    }


    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    
    //call API for load users' data
    function callApiGetUserData(){
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
        type: "GET",
        success: function(result){
          console.log(result);
          loadUserDataToTable(result);
        },
        error: function(ajaxContext){
          console.log(ajaxContext.status)
        }
      });
    }

    //cal API for load user by id
    function callApiGetUserById(paramId){

      var vId = paramId;
      console.log(vId);

      $.ajax({
        url: gBASE_URL + vId,
        type: "GET", 
        success: function(result){
          console.log(result);
          loadDataOnEditModal(result);
          return result;
        },
        error: function(ajaxContext){
          console.log(ajaxContext.status)
        }
      });
    }
    
    //load data to the table
    function loadUserDataToTable(paramUser){
      gUserTable.clear();
      gUserTable.rows.add(paramUser);
      gUserTable.draw();
     
    };

    //function of Edit Button
    function btnEditUserClick(paramElement){
      var vElement = paramElement;
      console.log("Edited ID: " + rowIdClick(vElement));
    }

    //function of Delete Button
    function btnDeleteUserClick(paramElement){
      var vElementDelete = paramElement;
      console.log("Deleted ID: " + rowIdClick(vElementDelete));
    }

    //function on getting id of the clicked row
    function rowIdClick(paramElement){
      var vRowClick = $(paramElement).parents('tr');
      var vTable = $("#table-user").DataTable();
      var DataRow = vTable.row(vRowClick).data();
      gVId = DataRow.id;
      return gVId
    }

    //function for getting the inputed data
    function getInputData(){
      
      //set variables for input elements
      var gFirstNameElement = $("#inp-first-name");
      var gLastNameElement = $("#inp-last-name");
      var gSubjectElement = $("#inp-subject");
      var gCountryElement = $("#select-country");
      var gCustomerTypeElement = $("#select-customer-type");
      var gRegisterStatusElement = $("#select-register-status");

      //create an user object
      var vUserObject = new Object;

      //add value for the object
      vUserObject.firstname = $.trim(gFirstNameElement.val());
      vUserObject.lastname = $.trim(gLastNameElement.val());
      vUserObject.subject = $.trim(gSubjectElement.val());
      vUserObject.country = $.trim(gCountryElement.val());
      vUserObject.customerType = $.trim(gCustomerTypeElement.val());
     
      return vUserObject;
    }

    //function for validating the inputed data
    function validateInputData(paramData){
        
        if (paramData.firstname == ""){
        alert("Please input firstname !!!");
        return false;
        }
        if (paramData.lastname == ""){
          alert("Please input lastname !!!");
          return false;
        }
        if (paramData.subject == ""){
          alert("Please input subject !!!");
          return false;
        }
        if (paramData.country == ""){
          alert("Please choose the country !!!");
          return false;
        }
        if (paramData.customerType == ""){
          alert("Please choose the customer's type !!!");
          return false;
        }
        if (paramData.registerStatus == ""){
          alert("Please choose the register status !!!");
          return false;
        }
        return true;
    }

    //USER CREATION - handler for re-setting the form of user's creation
    function resetUserForm(){
      $("#inp-first-name").val("");
      $("#inp-last-name").val("");
      $("#inp-subject").val("");
      $("#select-country").val("");
      $("#select-customer-type").val("");
      $("#select-register-status").val("");
    }

    //USER CREATION - function for calling API to create the user
    function addUserByApiCall(paramData){

      $.ajax({
        url: gBASE_URL,
        type: "POST",
        contentType: "application/json",
        data: JSON.stringify(paramData),
        success: function(res){
          console.log("%cUPDATED INFORMATION: ", "color:orange", Object.entries(res));
          console.log("%cJSON: ", "color:orange", JSON.stringify(res, true, 2));
          handleUserCreateSuccess();

        },
        error: function(ajaxContext){
          console.log(ajaxContext.status);
        },
      })
    };

    //USER CREATION - handler if the creation is successful
    function handleUserCreateSuccess(){
      alert("The new user has been created successfully");
      //reload the data on the table
      callApiGetUserData();
      resetUserForm();
      $("#create-user-modal").modal('hide');
    }
   
    //USER EDIT - read data from Edit Modal
    function readDataOnEditModal(){
      
      var vEditUser = new Object;

      vEditUser.firstname = $("#inp-first-name-edit").val();
      vEditUser.lastname = $("#inp-last-name-edit").val();
      vEditUser.subject = $("#inp-subject-edit").val();
      vEditUser.country = $("#select-country-edit").val();
      vEditUser.customerType = $("#select-customer-type-edit").val();
      vEditUser.registerStatus = $("#select-register-status-edit").val();
      vEditUser.id = gVId;
      console.log(vEditUser);
      return vEditUser;
      
    }

    //USER EDIT - load data to Edit Modal
    function loadDataOnEditModal(paramEdit){
      console.log(paramEdit);

      gVId = paramEdit.id;
      $("#inp-first-name-edit").val(paramEdit.firstname);
      $("#inp-last-name-edit").val(paramEdit.lastname);
      $("#inp-subject-edit").val(paramEdit.subject);
      $("#select-country-edit").val(paramEdit.country);
      $("#select-customer-type-edit").val(paramEdit.customerType);
      $("#select-register-status-edit").val(paramEdit.registerStatus);
    }

    //USER EDIT - function for calling API to edit the user's data
    function editUserByApiCall(paramId, paramUser){

      var vId = paramId;

      $.ajax({
      url: gBASE_URL + vId,
      type: "PUT",
      contentType: "application/json",
      data: JSON.stringify(paramUser),
      success: function(res){
        console.log("%cUPDATED INFORMATION: ", "color:orange", Object.entries(res));
        console.log("%cJSON: ", "color:orange", JSON.stringify(res, true, 2));
        handleUserEditSuccess();
      },
      error: function(ajaxContext){
        console.log(ajaxContext.status);
      },
      });
    };

    //USER EDIT - handler if the edit is successful
    function handleUserEditSuccess(){
      alert("The new user has been edited successfully");
      //reload the data on the table
      callApiGetUserData();
      resetUserForm();
      $("#edit-user-modal").modal('hide');
    }

</script>
</body>

</html>
